Index: branches/proxy/src/defs/class_id.h
===================================================================
--- branches/proxy/src/defs/class_id.h	(revision 9346)
+++ branches/proxy/src/defs/class_id.h	(revision 9347)
@@ -127,4 +127,5 @@
   CL_NETWORK_MANAGER            =    0x00000050,
   CL_SHARED_NETWORK_DATA        =    0x00000051,
+  CL_PROXY_SETTINGS             =    0x00000052,
   CL_ATMOSPHERIC_ENGINE         =    0x00000061,
 
@@ -422,4 +423,5 @@
   CL_PLAYER_STATS               =    0x00000d09,
   CL_SIMPLE_SYNC                =    0x00000d0a,
+  CL_NETWORK_MONITOR            =    0x00000d0b,
 
 
Index: branches/proxy/src/lib/collision_detection/obb_tree_node.cc
===================================================================
--- branches/proxy/src/lib/collision_detection/obb_tree_node.cc	(revision 9346)
+++ branches/proxy/src/lib/collision_detection/obb_tree_node.cc	(revision 9347)
@@ -434,4 +434,5 @@
     }
   }
+  delete [] triangleCenter;
   PRINTF(4)("\nPartition1: got \t%i Vertices \nPartition2: got \t%i Vertices\n", partition1.size(), partition2.size());
 
@@ -476,6 +477,6 @@
     return;
 
-  float distanceMax = this->bvElement->radius + ((OBBTreeNode*)treeNode)->bvElement->radius;
-  float distance = fabs((nodeA->getAbsCoor() - nodeB->getAbsCoor()).len());
+//   float distanceMax = this->bvElement->radius + ((OBBTreeNode*)treeNode)->bvElement->radius;
+//   float distance = fabs((nodeA->getAbsCoor() - nodeB->getAbsCoor()).len());
 
 
Index: branches/proxy/src/lib/coord/p_node.h
===================================================================
--- branches/proxy/src/lib/coord/p_node.h	(revision 9346)
+++ branches/proxy/src/lib/coord/p_node.h	(revision 9347)
@@ -20,5 +20,4 @@
 
 #include "base_object.h"
-#include "stdincl.h"
 #include "synchronizeable.h"
 
@@ -112,5 +111,5 @@
   /** @returns the absolute position */
   inline const Vector& getLastAbsCoor () const { return this->lastAbsCoordinate; };
-  
+
   void shiftCoor (const Vector& shift);
   void shiftCoor (float x, float y, float z) { this->shiftCoor(Vector(x, y, z)); };
Index: branches/proxy/src/lib/graphics/effects/snow_effect.cc
===================================================================
--- branches/proxy/src/lib/graphics/effects/snow_effect.cc	(revision 9346)
+++ branches/proxy/src/lib/graphics/effects/snow_effect.cc	(revision 9347)
@@ -1,14 +1,14 @@
 /*
-	orxonox - the future of 3D-vertical-scrollers
-
-	Copyright (C) 2004 orx
-
-	This program is free software; you can redistribute it and/or modify
-	it under the terms of the GNU General Public License as published by
-	the Free Software Foundation; either version 2, or (at your option)
-	any later version.
+        orxonox - the future of 3D-vertical-scrollers
+
+        Copyright (C) 2004 orx
+
+        This program is free software; you can redistribute it and/or modify
+        it under the terms of the GNU General Public License as published by
+        the Free Software Foundation; either version 2, or (at your option)
+        any later version.
 
 ### File Specific:
-	main-programmer: hdavid, amaechler
+        main-programmer: hdavid, amaechler
 */
 
@@ -35,5 +35,4 @@
 SHELL_COMMAND(deactivate, SnowEffect, deactivateSnow);
 
-using namespace std;
 
 CREATE_SCRIPTABLE_CLASS(SnowEffect, CL_SNOW_EFFECT,
@@ -46,20 +45,19 @@
 SnowEffect::SnowEffect(const TiXmlElement* root)
 {
-	this->setClassID(CL_SNOW_EFFECT, "SnowEffect");
-
-	this->init();
-
-	if (root != NULL)
-		this->loadParams(root);
-
-	//load wind sound
-	if (this->snowWindForce >= 1) {
-		if (this->windBuffer != NULL)
-			ResourceManager::getInstance()->unload(this->windBuffer);
-	  this->windBuffer = (OrxSound::SoundBuffer*)ResourceManager::getInstance()->load("sound/atmosphere/wind.wav", WAV);
-	}
+        this->setClassID(CL_SNOW_EFFECT, "SnowEffect");
+
+        this->init();
+
+        if (root != NULL)
+                this->loadParams(root);
+
+        this->windBuffer = NULL;
+        //load wind sound
+        if (this->snowWindForce >= 1) {
+          this->windBuffer = (OrxSound::SoundBuffer*)ResourceManager::getInstance()->load("sound/atmosphere/wind.wav", WAV);
+        }
 
   if(snowActivate) {
-		this->activate();
+                this->activate();
     SnowEffect::snowParticles->precache((int) this->snowLife);
   }
@@ -69,5 +67,5 @@
 SnowEffect::~SnowEffect()
 {
-	this->deactivate();
+        this->deactivate();
 }
 
@@ -76,52 +74,52 @@
 void SnowEffect::loadParams(const TiXmlElement* root)
 {
-	WeatherEffect::loadParams(root);
-
-	LoadParam(root, "numParticles", this, SnowEffect, numParticles);
-	LoadParam(root, "materialTexture", this, SnowEffect, materialTexture);
-	LoadParam(root, "lifeSpans", this, SnowEffect, lifeSpan);
-	LoadParam(root, "radius", this, SnowEffect, radius);
-	LoadParam(root, "mass", this, SnowEffect, mass);
-	LoadParam(root, "emissionRate", this, SnowEffect, emissionRate);
-	LoadParam(root, "emissionVelocity", this, SnowEffect, emissionVelocity);
-	LoadParam(root, "wind", this, SnowEffect, wind);
-	LoadParam(root, "size", this, SnowEffect, size);
-	LoadParam(root, "coord", this, SnowEffect, coord);
+        WeatherEffect::loadParams(root);
+
+        LoadParam(root, "numParticles", this, SnowEffect, numParticles);
+        LoadParam(root, "materialTexture", this, SnowEffect, materialTexture);
+        LoadParam(root, "lifeSpans", this, SnowEffect, lifeSpan);
+        LoadParam(root, "radius", this, SnowEffect, radius);
+        LoadParam(root, "mass", this, SnowEffect, mass);
+        LoadParam(root, "emissionRate", this, SnowEffect, emissionRate);
+        LoadParam(root, "emissionVelocity", this, SnowEffect, emissionVelocity);
+        LoadParam(root, "wind", this, SnowEffect, wind);
+        LoadParam(root, "size", this, SnowEffect, size);
+        LoadParam(root, "coord", this, SnowEffect, coord);
   LoadParam(root, "cloudcolor", this, SnowEffect, setCloudColor);
   LoadParam(root, "skycolor", this, SnowEffect, setSkyColor);
   LoadParam(root, "fadetime", this, SnowEffect, setFadeTime);
 
-	LOAD_PARAM_START_CYCLE(root, element);
-	{
-		LoadParam_CYCLE(element, "option", this, SnowEffect, setSnowOption);
-	}
-	LOAD_PARAM_END_CYCLE(element);
+        LOAD_PARAM_START_CYCLE(root, element);
+        {
+                LoadParam_CYCLE(element, "option", this, SnowEffect, setSnowOption);
+        }
+        LOAD_PARAM_END_CYCLE(element);
 }
 
 void SnowEffect::init()
 {
-	this->emitter = new PlaneEmitter();
-
-	// Default values
-	this->snowActivate = false;
-	this->snowMove = false;
-	this->particles = 12000;
-	this->texture = "maps/snow_flake_01_32x32.png";
-	this->snowLife = 8;
-	this->randomLife = 2;
-	this->snowRadius = 3.5;
-	this->randomRadius = 1;
-	this->snowMass = 1.0;
-	this->randomMass = 0.3;
-	this->rate = 900;
-	this->velocity = -100;
-	this->randomVelocity = 5;
-	this->angle = 0.5;
-	this->randomAngle = 0.2;
-	this->alpha = 0.5;
-	this->snowSize = Vector2D(2500, 2500);
-	this->snowCoord = Vector(100,450,400);
-	this->snowWindForce = 1;
-  
+        this->emitter = new PlaneEmitter();
+
+        // Default values
+        this->snowActivate = false;
+        this->snowMove = false;
+        this->particles = 12000;
+        this->texture = "maps/snow_flake_01_32x32.png";
+        this->snowLife = 8;
+        this->randomLife = 2;
+        this->snowRadius = 3.5;
+        this->randomRadius = 1;
+        this->snowMass = 1.0;
+        this->randomMass = 0.3;
+        this->rate = 900;
+        this->velocity = -100;
+        this->randomVelocity = 5;
+        this->angle = 0.5;
+        this->randomAngle = 0.2;
+        this->alpha = 0.5;
+        this->snowSize = Vector2D(2500, 2500);
+        this->snowCoord = Vector(100,450,400);
+        this->snowWindForce = 1;
+
   this->fadeTime = 10;
   this->cloudColor = Vector(0.2f, 0.2f, 0.2f);
@@ -131,31 +129,31 @@
 void SnowEffect::activate()
 {
-	PRINTF(3)("Activating SnowEffect\n");
-
-	this->snowActivate = true;
-
-	SnowEffect::snowParticles = new SpriteParticles(particles);
-	SnowEffect::snowParticles->setName("SnowEffectTrailParticles");
-	SnowEffect::snowParticles->setMaterialTexture(texture);
-	SnowEffect::snowParticles->setLifeSpan(snowLife, randomLife);
-	SnowEffect::snowParticles->setRadius(0.0, snowRadius, randomRadius);
-	SnowEffect::snowParticles->setRadius(0.2, snowRadius, randomRadius*0.8);
-	SnowEffect::snowParticles->setRadius(1.0, snowRadius, randomRadius*0.5);
-	SnowEffect::snowParticles->setMass(0, snowMass, randomMass);
-	SnowEffect::snowParticles->setColor(0,1, 1, 1, alpha);
-	SnowEffect::snowParticles->setColor(.5, .6, .6, .6, alpha/2);
-	SnowEffect::snowParticles->setColor(1, .0, .0, .0, .0);
-
-	this->emitter->setSystem(SnowEffect::snowParticles);
-
-	this->emitter->setRelCoor(snowCoord);
-	this->emitter->setEmissionRate(rate);
-	this->emitter->setEmissionVelocity(velocity, randomVelocity);
-	this->emitter->setSpread(angle * this->snowWindForce , randomAngle * this->snowWindForce);
-	this->emitter->setSize(snowSize);
+        PRINTF(3)("Activating SnowEffect\n");
+
+        this->snowActivate = true;
+
+        SnowEffect::snowParticles = new SpriteParticles(particles);
+        SnowEffect::snowParticles->setName("SnowEffectTrailParticles");
+        SnowEffect::snowParticles->setMaterialTexture(texture);
+        SnowEffect::snowParticles->setLifeSpan(snowLife, randomLife);
+        SnowEffect::snowParticles->setRadius(0.0, snowRadius, randomRadius);
+        SnowEffect::snowParticles->setRadius(0.2, snowRadius, randomRadius*0.8);
+        SnowEffect::snowParticles->setRadius(1.0, snowRadius, randomRadius*0.5);
+        SnowEffect::snowParticles->setMass(0, snowMass, randomMass);
+        SnowEffect::snowParticles->setColor(0,1, 1, 1, alpha);
+        SnowEffect::snowParticles->setColor(.5, .6, .6, .6, alpha/2);
+        SnowEffect::snowParticles->setColor(1, .0, .0, .0, .0);
+
+        this->emitter->setSystem(SnowEffect::snowParticles);
+
+        this->emitter->setRelCoor(snowCoord);
+        this->emitter->setEmissionRate(rate);
+        this->emitter->setEmissionVelocity(velocity, randomVelocity);
+        this->emitter->setSpread(angle * this->snowWindForce , randomAngle * this->snowWindForce);
+        this->emitter->setSize(snowSize);
 
   if (this->snowWindForce != 0)
     this->soundSource.play(this->windBuffer, 0.1f * this->snowWindForce, true);
-  
+
   // Store cloud- and sky color before the snow
   this->oldCloudColor = CloudEffect::cloudColor;
@@ -171,12 +169,12 @@
 void SnowEffect::deactivate()
 {
-	PRINTF(3)("Deactivating SnowEffect\n");
-
-	this->snowActivate = false;
-	this->emitter->setSystem(NULL);
-
-	if (this->windBuffer != NULL)
-		ResourceManager::getInstance()->unload(this->windBuffer);
-  
+        PRINTF(3)("Deactivating SnowEffect\n");
+
+        this->snowActivate = false;
+        this->emitter->setSystem(NULL);
+
+        if (this->windBuffer != NULL)
+                ResourceManager::getInstance()->unload(this->windBuffer);
+
   // Restore the old cloud- and sky color
   CloudEffect::changeCloudColor(this->oldCloudColor, this->fadeTime);
@@ -186,50 +184,50 @@
 void SnowEffect::draw() const
 {
-	if (!this->snowActivate)
-		return;
+        if (!this->snowActivate)
+                return;
 }
 
 void SnowEffect::tick(float dt)
 {
-	if (!this->snowActivate)
-		return;
-
-	/*
-	float distance = (State::getCameraNode()->getAbsCoor() - Vector(snowCoord.x, State::getCameraNode()->getAbsCoor().y, snowCoord.z)).len();
-
-	if(activated)
-	{
-	if(distance > 0.3*snowSize.x || distance > 0.3*snowSize.y)
-			this->deactivate();
-	else if(distance > 0.25*snowSize.x || distance > 0.25*snowSize.y)
-	this->alpha = 0.15;
-	else if(distance > 0.2*snowSize.x || distance > 0.2*snowSize.y)
-	this->alpha = 0.25;
-	else if(distance > 0.1*snowSize.x || distance > 0.1*snowSize.y)
-	this->alpha = 0.4;
-
-	SnowEffect::snowParticles->setColor(0,1, 1, 1, alpha);
-	SnowEffect::snowParticles->setColor(.5, .6, .6, .6, alpha/2);
-	SnowEffect::snowParticles->setColor(1, .0, .0, .0, .0);
-	}
-	else
-	{
-	if(distance < 0.3*snowSize.x || distance < 0.3*snowSize.y )
-	this->activate();
-	if( distance < 0.25*snowSize.x || distance < 0.25*snowSize.y )
-	this->alpha = 0.25;
-	else if( distance < 0.2*snowSize.x || distance < 0.2*snowSize.y )
-	this->alpha = 0.4;
-	else if( distance < 0.1*snowSize.x || distance < 0.1*snowSize.y )
-	this->alpha = 0.5;
-
-	SnowEffect::snowParticles->setColor(0,1, 1, 1, alpha);
-	SnowEffect::snowParticles->setColor(.5, .6, .6, .6, alpha/2);
-	SnowEffect::snowParticles->setColor(1, .0, .0, .0, .0);
-	}*/
-
-	if (this->snowMove) {
-		this->snowCoord = State::getCameraNode()->getAbsCoor();
-		this->emitter->setRelCoor(this->snowCoord.x , this->snowCoord.y+300, this->snowCoord.z);
-	}
-}
+        if (!this->snowActivate)
+                return;
+
+        /*
+        float distance = (State::getCameraNode()->getAbsCoor() - Vector(snowCoord.x, State::getCameraNode()->getAbsCoor().y, snowCoord.z)).len();
+
+        if(activated)
+        {
+        if(distance > 0.3*snowSize.x || distance > 0.3*snowSize.y)
+                        this->deactivate();
+        else if(distance > 0.25*snowSize.x || distance > 0.25*snowSize.y)
+        this->alpha = 0.15;
+        else if(distance > 0.2*snowSize.x || distance > 0.2*snowSize.y)
+        this->alpha = 0.25;
+        else if(distance > 0.1*snowSize.x || distance > 0.1*snowSize.y)
+        this->alpha = 0.4;
+
+        SnowEffect::snowParticles->setColor(0,1, 1, 1, alpha);
+        SnowEffect::snowParticles->setColor(.5, .6, .6, .6, alpha/2);
+        SnowEffect::snowParticles->setColor(1, .0, .0, .0, .0);
+        }
+        else
+        {
+        if(distance < 0.3*snowSize.x || distance < 0.3*snowSize.y )
+        this->activate();
+        if( distance < 0.25*snowSize.x || distance < 0.25*snowSize.y )
+        this->alpha = 0.25;
+        else if( distance < 0.2*snowSize.x || distance < 0.2*snowSize.y )
+        this->alpha = 0.4;
+        else if( distance < 0.1*snowSize.x || distance < 0.1*snowSize.y )
+        this->alpha = 0.5;
+
+        SnowEffect::snowParticles->setColor(0,1, 1, 1, alpha);
+        SnowEffect::snowParticles->setColor(.5, .6, .6, .6, alpha/2);
+        SnowEffect::snowParticles->setColor(1, .0, .0, .0, .0);
+        }*/
+
+        if (this->snowMove) {
+                this->snowCoord = State::getCameraNode()->getAbsCoor();
+                this->emitter->setRelCoor(this->snowCoord.x , this->snowCoord.y+300, this->snowCoord.z);
+        }
+}
Index: branches/proxy/src/lib/graphics/importer/md3/md3_animation_cfg.cc
===================================================================
--- branches/proxy/src/lib/graphics/importer/md3/md3_animation_cfg.cc	(revision 9346)
+++ branches/proxy/src/lib/graphics/importer/md3/md3_animation_cfg.cc	(revision 9347)
@@ -19,11 +19,9 @@
 #include "md3_animation.h"
 
-#include "tokenizer.h"
+#include "substring.h"
 #include "helper_functions.h"
 
 #include "debug.h"
 
-#include <stdio.h>
-#include <stdlib.h>
 
 
@@ -98,6 +96,5 @@
         if( inHeader && line.find("sex") == 0) {
           //parse line: sex [m | f | ...]
-          std::vector<std::string> tokens;
-          Tokenizer::tokenize(line, tokens, " \t\n\r\f/");
+          SubString tokens(line, " \t\n\r\f/");
 
           std::string sexStr = tokens.back();
@@ -115,6 +112,5 @@
         else if( inHeader && line.find("headoffset") == 0) {
           // parse line: headoffset X Y Z
-          std::vector<std::string> tokens;
-          Tokenizer::tokenize(line, tokens, " \t\n\r\f/");
+          SubString tokens(line, " \t\n\r\f/");
 
           float z = atof(tokens.back().c_str()); tokens.pop_back();
@@ -128,6 +124,5 @@
         else if( inHeader && line.find("footsteps") == 0) {
           //parse line: footsteps [normal | mech | ...]
-          std::vector<std::string> tokens;
-          Tokenizer::tokenize(line, tokens, " \t\n\r\f/");
+          SubString tokens (line, " \t\n\r\f/");
 
           this->footsteps = tokens.back();
@@ -187,6 +182,5 @@
     // parse the line:
     // first frame, num frames, looping frames, frames per second (fps)
-    std::vector<std::string> tokens;
-    Tokenizer::tokenize(line, tokens, " \t\n\r\f/");
+    SubString tokens(line, " \t\n\r\f/");
 
     anim->fps = atoi(tokens.back().c_str()); tokens.pop_back();
Index: branches/proxy/src/lib/lang/base_object.cc
===================================================================
--- branches/proxy/src/lib/lang/base_object.cc	(revision 9346)
+++ branches/proxy/src/lib/lang/base_object.cc	(revision 9347)
@@ -21,9 +21,4 @@
 #include "util/loading/load_param.h"
 #include "class_list.h"
-
-#include "synchronizeable.h"
-
-using namespace std;
-
 
 /**
@@ -50,5 +45,4 @@
   ClassList::removeFromClassList(this);
 
-  //  delete []this->className;
   if (this->xmlElem != NULL)
     delete this->xmlElem;
@@ -61,10 +55,12 @@
 void BaseObject::loadParams(const TiXmlElement* root)
 {
-  // all loadParams should sometime arrive here.
+  // all loadParams should arrive here, and be tested for (root != NULL)
   assert (root != NULL);
 
+  // copy the xml-element for to know how it was loaded.
   if (this->xmlElem != NULL)
     delete this->xmlElem;
   this->xmlElem = root->Clone();
+
   // name setup
   LoadParam(root, "name", this, BaseObject, setName)
@@ -92,4 +88,5 @@
 /**
  * @brief set the name of the Object
+ * @param objectName The new name of the Object.
  */
 void BaseObject::setName (const std::string& objectName)
@@ -164,16 +161,7 @@
  * @returns true on match, false otherwise.
  */
-bool BaseObject::operator==(const std::string& objectName)
+bool BaseObject::operator==(const std::string& objectName) const
 {
   return (this->objectName == objectName);
 }
 
-
-/**
- * @brief displays everything this class is
- * @TODO REIMPLEMENT WITH SENSE.
- */
-void BaseObject::whatIs() const
-{
-
-}
Index: branches/proxy/src/lib/lang/base_object.h
===================================================================
--- branches/proxy/src/lib/lang/base_object.h	(revision 9346)
+++ branches/proxy/src/lib/lang/base_object.h	(revision 9347)
@@ -1,12 +1,16 @@
 /*!
  * @file base_object.h
-  *  Definition of the base object class.
-
-    This is a global handler for all classes.
-*/
+ * @brief Definition of the BaseObject class.
+ *
+ * This is a global handler for all classes Object and Class names
+ *
+ * BaseObject is the class, that handles object registration and
+ * is the only write-access member of ClassList, where the Objects
+ * References are stored.
+ */
 
 
-#ifndef _BASE_OBJECT_H
-#define _BASE_OBJECT_H
+#ifndef __BASE_OBJECT_H_
+#define __BASE_OBJECT_H_
 
 #include "class_id.h"
@@ -41,9 +45,8 @@
   bool isA (ClassID classID) const;
   bool isA (const std::string& className) const;
-  void whatIs() const;
 
-  bool operator==(const std::string& objectName);
   /** @param classID comparer for a ClassID @returns true on match, false otherwise */
-  bool operator==(ClassID classID) { return this->isA(classID); };
+  bool operator==(ClassID classID) const  { return this->isA(classID); };
+  bool operator==(const std::string& objectName) const;
 
 protected:
@@ -54,5 +57,4 @@
 
 private:
-
   std::string        className;        //!< the name of the class
   long               classID;          //!< this is the id from the class_id.h enumeration
@@ -64,3 +66,3 @@
 };
 
-#endif /* _BASE_OBJECT_H */
+#endif /* __BASE_OBJECT_H_ */
Index: branches/proxy/src/lib/network/Makefile.am
===================================================================
--- branches/proxy/src/lib/network/Makefile.am	(revision 9346)
+++ branches/proxy/src/lib/network/Makefile.am	(revision 9347)
@@ -8,5 +8,4 @@
 		      shared_network_data.cc \
 		      network_socket.cc \
-		      connection_monitor.cc \
 		      network_stream.cc \
                       data_stream.cc \
@@ -20,4 +19,5 @@
 		      network_game_manager.cc \
 		      converter.cc \
+		      peer_info.cc \
 		      message_manager.cc \
 		      network_log.cc \
@@ -25,4 +25,10 @@
 		      player_stats.cc \
 		      udp_broadcast.cc \
+		      \
+		      proxy/proxy_settings.cc \
+		      \
+      		      monitor/connection_monitor.cc \
+		      monitor/network_monitor.cc \
+		      monitor/network_node.cc \
 		      \
 		      synchronizeable_var/synchronizeable_var.cc \
@@ -33,5 +39,8 @@
 		      synchronizeable_var/synchronizeable_float.cc \
 		      synchronizeable_var/synchronizeable_bool.cc \
-		      synchronizeable_var/synchronizeable_uint.cc 
+		      synchronizeable_var/synchronizeable_uint.cc \
+		      synchronizeable_var/synchronizeable_ip.cc \
+		      \
+		      ip.cc
 
 
@@ -42,5 +51,4 @@
                  shared_network_data.h \
                  network_socket.h \
-                 connection_monitor.h \
 		 network_stream.h \
                  data_stream.h \
@@ -54,4 +62,5 @@
 		 network_game_manager.h \
 		 converter.h \
+		 peer_info.h \
 		 netdefs.h \
 		 message_manager.h \
@@ -60,4 +69,10 @@
 		 player_stats.h \
 		 udp_broadcast.h \
+		 \
+		 proxy/proxy_settings.cc \
+		 \
+                 monitor/connection_monitor.h \
+                 monitor/network_monitor.h \
+                 monitor/network_node.h \
 		 \
 		 synchronizeable_var/synchronizeable_var.h \
@@ -68,5 +83,8 @@
 		 synchronizeable_var/synchronizeable_float.h \
 		 synchronizeable_var/synchronizeable_bool.h \
-		 synchronizeable_var/synchronizeable_uint.h
+		 synchronizeable_var/synchronizeable_uint.h \
+		 synchronizeable_var/synchronizeable_ip.h \
+		 \
+		 ip.h
 
 
Index: branches/proxy/src/lib/network/handshake.cc
===================================================================
--- branches/proxy/src/lib/network/handshake.cc	(revision 9346)
+++ branches/proxy/src/lib/network/handshake.cc	(revision 9347)
@@ -10,12 +10,9 @@
 
 ### File Specific:
-   main-programmer: christoph
-   co-programmer:
+   main-programmer: Christoph Renner (rennerc@ee.ethz.ch)
+   co-programmer: Patirck Boenzli (boenzlip@orxonox.ethz.ch)
 */
 
 
-/* this is for debug output. It just says, that all calls to PRINT() belong to the DEBUG_MODULE_NETWORK module
-   For more information refere to https://www.orxonox.net/cgi-bin/trac.cgi/wiki/DebugOutput
-*/
 #define DEBUG_MODULE_NETWORK
 
@@ -25,5 +22,9 @@
 #include "debug.h"
 
-Handshake::Handshake( bool server, int clientId, int networkGameManagerId, int messageManagerId )
+
+
+
+
+ Handshake::Handshake( int nodeType, int clientId, int networkGameManagerId, int messageManagerId )
   : Synchronizeable()
 {
@@ -31,6 +32,5 @@
   this->setClassID(CL_HANDSHAKE, "Handshake");
 
-  this->setIsServer(server);
-
+  // register all variable handlers
   orxId_handler = registerVarId( new SynchronizeableInt( &localState.orxId, &remoteState.orxId, "orxonoxId", PERMISSION_ALL ) );
   version_handler = registerVarId( new SynchronizeableInt( &localState.version, &remoteState.version, "version", PERMISSION_ALL ) );
@@ -42,8 +42,14 @@
   errorString_handler = registerVarId( new SynchronizeableString( &localState.errorString, &remoteState.errorString, "errorString", PERMISSION_ALL ) );
 
+  this->nodeTypeHandler = registerVarId( new SynchronizeableInt( &localState.nodeType, &remoteState.nodeType, "nodeType", PERMISSION_ALL ) );
+
   candel_id = registerVarId( new SynchronizeableInt( &localState.canDel, &remoteState.canDel, "canDel", PERMISSION_ALL ) );
-  
+
   registerVar( new SynchronizeableString( &localState.preferedNickName, &remoteState.preferedNickName, "preferedNickName", PERMISSION_ALL ) );
+  // now synchronize only two of the available proxy server addresses
+  registerVar( new SynchronizeableIP( &localState.proxy1, &remoteState.proxy1, "proxy server 1", PERMISSION_ALL ) );
+  registerVar( new SynchronizeableIP( &localState.proxy2, &remoteState.proxy1, "proxy server 2", PERMISSION_ALL ) );
 
+  // init the local state
   localState.completed = 0;
   localState.error = 0;
@@ -54,6 +60,12 @@
   localState.orxId = _ORXONOX_ID;
   localState.version = _ORXONOX_VERSION;
+  localState.nodeType = nodeType;
   localState.canDel = 0;
+  localState.redirectProxy = 0;
+  localState.proxy1 = IP(0, 0);
+  localState.proxy2 = IP (0, 0);
 
+
+  // init the remote state
   remoteState.completed = 0;
   remoteState.error = 0;
@@ -64,9 +76,15 @@
   remoteState.orxId = 0;
   remoteState.version = 0;
+  remoteState.nodeType = NET_CLIENT;
   remoteState.canDel = 0;
+  remoteState.redirectProxy = 0;
+  remoteState.proxy1 = IP(0, 0);
+  remoteState.proxy2 = IP(0, 0);
 
+  // activate the synchronization process
   this->setSynchronized(true);
   PRINTF(0)("Handshake created clientId = %d\n", clientId);
 }
+
 
 /**
@@ -78,5 +96,6 @@
   for ( std::list<int>::iterator it = id.begin(); it != id.end(); it++ )
   {
-    if ( *it == orxId_handler )
+    // orxonox id handler
+    if ( *it == this->orxId_handler )
     {
       if ( remoteState.orxId != _ORXONOX_ID )
@@ -87,8 +106,8 @@
         continue;
       }
-
     }
 
-    if ( *it == version_handler )
+    // orxonox version handler
+    if ( *it == this->version_handler )
     {
       if ( remoteState.version != _ORXONOX_VERSION )
@@ -99,7 +118,24 @@
         continue;
       }
-
     }
 
+    // node type handler: for each node type there is a specific action to be taken
+    if ( *it == this->nodeTypeHandler)
+    {
+      if ( remoteState.nodeType == NET_MASTER_SERVER )
+      {
+        continue;
+      }
+      else if( remoteState.nodeType == NET_PROXY_SERVER_ACTIVE)
+      {
+        continue;
+      }
+      else if( remoteState.nodeType == NET_CLIENT)
+      {
+        continue;
+      }
+    }
+
+    // cancel
     if ( *it == candel_id )
     {
@@ -109,9 +145,10 @@
   }
 
-  if (
-      remoteState.orxId == _ORXONOX_ID &&
-      remoteState.version == _ORXONOX_VERSION
-     )
+  // handshake completed
+  if ( remoteState.orxId == _ORXONOX_ID &&
+       remoteState.version == _ORXONOX_VERSION )
+  {
     localState.completed = 1;
+  }
 }
 
